import datetime
from restaurant.models import (
count_tokens, item_desc,view_v_item_desc_1,
account_category,account,expenses,
view_v_all_expenses_full_1,view_v_all_accounts_full_1,
employee, employees_wages,
employee_wages_expenses,
view_v_lab_test_1_a,
lab_test, lab_test_fee,
medicine, medicine_cost,
admission_cost,admission,
view_v_medicine_1_a,view_v_admission_cost_1_a,
medicine_product,medicine_item,
service_category,
medical_service, medical_service_fee,
lab_test_category, medicine_category, consultation, admission, consultation_cost,
admission_cost, diagnosis_category, diagnosis,
)
from django.db.models import Max
from restaurant.general.general import general
from restaurant.purchases.purchasesFunctions import purchases
from restaurant.uoqFunctions import uoq

gen=general()
pur=purchases()
newUoq=uoq()



class expensesC():
    expenses_init=''
        #return 0

    def loadExpensesReport008(self,_reportType,_dateFrom,_dateTo):
        xStr=self.loadExpensesReports008Data(_dateFrom, _dateTo)
        return xStr

    def loadExpensesReports008Data(self, _dateFrom, _dateTo):
        x=0
        iList=[]
        final_dict_list=[]
        inv_expenses=view_v_all_expenses_full_1.objects.values().filter(trans_date__gte=_dateFrom, trans_date__lte=_dateTo)
        inv_tokens_details=''
        tokensStr=''
        tokensStr+=''
        x=0
        allTotalCost=0
        for a in inv_expenses:
            y=0
            totalCost=a['amount']
            allTotalCost+=float(totalCost)
            myDict={
            "sno": x+1, "accountName":a['account_name'] ,"expensesDate":str(a['trans_date']),
            "amount": str(a['amount']), "details": a['details']
            }
            iList.append(myDict)

            x=x+1
        myDict={
        "sno": x+1, "accountName":"Total" ,"expensesDate":"",
        "amount": str(allTotalCost), "details": ""
        }
        iList.append(myDict)

        print(iList)
        return iList


    def loadExpensesReport009(self,_reportType,_dateFrom,_dateTo):
        xStr=self.loadExpensesReports009Data(_dateFrom, _dateTo)

        return xStr

    def loadExpensesReports009Data(self, _dateFrom, _dateTo):
        x=0
        iList=[]
        final_dict_list=[]
        inv_expenses=view_v_all_expenses_full_1.objects.values().filter(trans_date__gte=_dateFrom,trans_date__lte=_dateTo)
        inv_expenses_list=list(inv_expenses)
        inv_accounts=view_v_all_accounts_full_1.objects.values()
        inv_accounts_list=list(inv_accounts)
        tokensStr=''
        tokensStr+=''
        x=0
        allTotalCost=0
        qtyTotalUnit=0
        qtyTotalNotUnit=0
        qtyTotal=0
        qtyStr=''
        iList=[]
        for a in inv_accounts_list:
            qtyTotalUnit=0
            qtyTotalNotUnit=0
            qtyTotal=0
            qtyStr=''

            qtyTotal=sum([ b['amount'] for b in inv_expenses_list if b['account_id']==a['account_id'] ])
            #qtyStr='' + str(qtyTotal) + ' ' + a['uoq'] + '(s)'
            iList.append({ 'accountName': a['account_name'], 'amountTotal': str(qtyTotal) })

        print(iList)
        return iList

    def getItemUoqAndItemNames(self):
        inv=view_v_item_desc_with_uoq_1.objects.values()
        jStr='{"items":['
        y=0
        for a in inv:
            jStr+='{"itemDescId":"' + str(a['item_desc_id']) + '",'
            jStr+='"itemDescName":"' + a['desc_name'] + '",'
            jStr+='"itemUoq":"' + a['uoq'] + '",'
            jStr+='"itemSingleUnit":"' + str(a['single_unit']) + '"'
            if y+1>=len(inv):
                jStr+='}'
            else:
                jStr+='},'
            y=y+1
        jStr+=']}'
        return jStr

    def insertNewExpensesToDb(self, _accountId, _amount, _transDate, _details):
        inv=expenses(
        account=account.objects.get(id=_accountId),
        amount=_amount,
        trans_date=_transDate,
        bk_status='Active',
        details=_details
        )
        inv.save()
        return 'success'


    def updateMedicineFeeToInActiveToDb(self, medicineProductId):
        inv=medicine_cost.objects.values().filter(
        medicine_product_id=medicineProductId,
        status='Active'
        ).update(status='InActive')
        #inv.save()
        return 'success'

    def insertNewMedicineCostToDb(self, medicineProductId, costAmount):
        self.updateMedicineFeeToInActiveToDb(medicineProductId)
        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=medicine_cost(
        medicine_product_id=medicineProductId,
        cost_amount=costAmount,
        ###creation_date=todayDatee,
        status='Active'
        )
        inv.save()
        return 'Medicine creation was successful'

    def updateMedicineCostToDb(self, medicineProductId, costAmount):
        self.updateMedicineFeeToInActiveToDb(medicineProductId)
        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=medicine_cost(
        medicine_product_id=medicineProductId,
        cost_amount=costAmount,
        ###creation_date=todayDatee,
        status='Active'
        )
        inv.save()
        return 'Medicine creation was successful'



    def insertNewMedicineToItemToDb(self, medicineProductId, itemId):
        x=0
        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=medicine_item(
        medicine_product_id=medicineProductId,
        item_id=itemId,
        ###creation_date=todayDatee, medicine_item
        status='Active'
        )
        inv.save()
        return x ###'Medicine creation was successful'

    def insertNewMedicineProductToDb(self, medicineId, productName, costAmount, itemId):
        #self.updateMedicineFeeToInActiveToDb(medicineId)
        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=medicine_product(
        medicine_id=medicineId,
        prod_name=productName,
        ###creation_date=todayDatee,
        status='Active'
        )
        inv.save()

        x=0
        msg=''
        medicineProductId=medicine_product.objects.values().aggregate(Max('id'))['id__max']

        if medicineProductId==0:
            x=x
        else:
            self.insertNewMedicineToItemToDb(medicineProductId, itemId)
            msg=self.insertNewMedicineCostToDb(medicineProductId, costAmount)
            x=x
        #max
        return msg ###'Medicine Cost creation was successful'


    def updateMedicineProductToDb(self, oldMedicalProductId, medicineId, productName, costAmount, itemId):

        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=medicine_product.objects.values().filter(
        medicine_id=medicineId
        ).update(prod_name=productName,)
        #inv.save()

        x=0
        msg=''
        medicineProductId=oldMedicalProductId ###medicine_product.objects.values().aggregate(Max('id'))['id__max']

        if medicineProductId==0:
            x=x
        else:
            #self.insertNewMedicineToItemToDb(medicineProductId, itemId)
            msg=self.updateMedicineCostToDb(medicineProductId, costAmount)
            x=x
        #max
        return msg ###'Medicine Cost creation was successful'

    def updateAdmissionFeeToInActiveToDb(self, admissionId):
        inv=admission_cost.objects.values().filter(
        admission_id=admissionId,
        status='Active'
        ).update(status='InActive')
        #inv.save()
        return 'success'


    def insertNewAdmissionFeeToDb(self, admissionId, feeAmount):
        self.updateAdmissionFeeToInActiveToDb(admissionId)
        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=admission_cost(
        admission_id=admissionId,
        fee_amount=feeAmount,
        ###creation_date=todayDatee,
        status='Active'
        )
        inv.save()
        return 'Admission Cost creation was successful'


    def insertNewAdmissionFeeToDb(self, admissionId, feeAmount):
        self.updateAdmissionFeeToInActiveToDb(admissionId)
        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=admission_cost(
        admission_id=admissionId,
        fee_amount=feeAmount,
        ###creation_date=todayDatee,
        status='Active'
        )
        inv.save()
        return 'Admission Cost creation was successful'

    def updateMedicalServiceFeeToInActiveToDb(self, serviceId,categoryId):
        inv=medical_service_fee.objects.values().filter(
        medical_service_id=serviceId,
        status='Active'
        ).update(status='InActive')

        inv=medical_service.objects.values().filter(
        id=serviceId,service_category_id=categoryId,
        status='Active'
        ).update(status='InActive')
        #inv.save()
        return 'success'


    def insertNewMedicalServiceToDb(self, serviceName,categoryId):
        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=medical_service(
        name=serviceName,
        service_category_id=categoryId,
        ###creation_date=todayDatee,
        status='Active'
        )
        inv.save()
        ###x=max
        serviceId=0
        serviceId=medical_service.objects.values().aggregate(Max('id'))['id__max']
        return serviceId

    def insertNewServiceFeeToDb(self, serviceId, feeAmount):
        #self.updateAdmissionFeeToInActiveToDb(admissionId)
        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=medical_service_fee(
        medical_service_id=serviceId,
        fee_amount=feeAmount,
        ###creation_date=todayDatee,
        status='Active'
        )
        inv.save()
        return 'Service Cost creation was successful'

    def insertNewMedicalServiceFeeToDb(self, serviceName, categoryId, feeAmount):
        serviceId=0
        serviceId=self.getServiceId(serviceName)
        self.updateMedicalServiceFeeToInActiveToDb(serviceId,categoryId)
        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        serviceId=self.insertNewMedicalServiceToDb( serviceName,categoryId)
        self.insertNewServiceFeeToDb( serviceId, feeAmount)
        return 'Admission Cost creation was successful'


    def insertNewServiceCategoryToDb(self, serviceCategory):
        #self.updateAdmissionFeeToInActiveToDb(admissionId)
        #todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=service_category(
        name=serviceCategory,
        status='Active'
        )
        inv.save()
        return 'Service category was successfully created'

    def insertNewPrimaryServiceCategoryToDb(self, serviceCategory, categoryType):
        x=0
        inv=''
        serviceCategoryId=0
        if categoryType=="Lab Test":
            serviceCategoryId=self.getServiceCategoryId(categoryType)
            inv=lab_test_category(
            name=serviceCategory,
            status='Active',
            service_category_id=serviceCategoryId
            )

        elif categoryType=="Medicine":
            serviceCategoryId=self.getServiceCategoryId(categoryType)
            inv=medicine_category(
            name=serviceCategory,
            status='Active',
            service_category_id=serviceCategoryId
            )
        elif categoryType=="Consultation":
            serviceCategoryId=self.getServiceCategoryId(categoryType)
            inv=consultation(
            name=serviceCategory,
            status='Active',
            service_category_id=serviceCategoryId
            )
        elif categoryType=="Admission":
            serviceCategoryId=self.getServiceCategoryId(categoryType)
            inv=admission(
            name=serviceCategory,
            status='Active',
            service_category_id=serviceCategoryId
            )
        elif categoryType=="Diagnosis":
            serviceCategoryId=self.getServiceCategoryId(categoryType)
            inv=diagnosis_category(
            name=serviceCategory,
            status='Active',
            service_category_id=serviceCategoryId
            )
        else:
            x=x

        inv.save()
        return 'Service category was successfully created'


    def insertNewPrimaryServiceToDb(self, medicalServiceCategory, medicalServiceName,feeAmount, categoryType):
        x=0
        inv=''
        print(medicalServiceCategory + "::" + medicalServiceName + "::" + str(feeAmount) + "::" + categoryType)
        medicalServiceCategoryId=0
        if categoryType=="Lab Test":  ##OVER HERE

            medicalServiceCategoryId=self.getPrimaryMedicalServiceId(medicalServiceCategory, categoryType)
            print("medicalServiceCategoryId::" + str(medicalServiceCategoryId))
            inv=lab_test(
            name=medicalServiceName,
            status='Active',
            lab_test_category_id=medicalServiceCategoryId
            )
            inv.save()
            labTestId=lab_test.objects.values().aggregate(Max('id'))['id__max']
            inv=lab_test_fee(
            fee_amount=feeAmount,
            status='Active',
            lab_test_id=labTestId
            )
            inv.save()

        elif categoryType=="Medicine":  ##OVER HERE
            #getPrimaryServiceCategoryIdUnd(self, serviceCategory, categoryType)
            medicalServiceCategoryId=self.getPrimaryServiceCategoryId(medicalServiceCategory, categoryType)
            print("medicalServiceCategoryId::" + str(medicalServiceCategoryId))
            inv=medicine(
            name=medicalServiceName,
            prod_name=medicalServiceName,
            status='Active',
            medicine_category_id=medicalServiceCategoryId
            )
            inv.save()

            medicineId=medicine.objects.values().aggregate(Max('id'))['id__max']


        elif categoryType=="Consultation":
            #medicalServiceCategoryId=self.getPrimaryMedicalServiceId(medicalServiceCategory,categoryType)
            medicalServiceCategoryId=self.getPrimaryServiceCategoryId(medicalServiceCategory,categoryType)
            inv=consultation(
            name=medicalServiceName,
            status='Active',
            service_category_id=medicalServiceCategoryId
            )
            inv.save()
            consultationId=consultation.objects.values().aggregate(Max('id'))['id__max']
            inv=consultation_cost(
            fee_amount=feeAmount,
            status='Active',
            consultation_id=consultationId
            )
            inv.save()

        elif categoryType=="Admission": ### admission
            medicalServiceCategoryId=self.getPrimaryServiceCategoryId(medicalServiceCategory,categoryType)
            inv=admission(
            name=medicalServiceName,
            status='Active',
            service_category_id=medicalServiceCategoryId
            )
            inv.save()
            admissionId=admission.objects.values().aggregate(Max('id'))['id__max']
            inv=admission_cost(
            fee_amount=feeAmount,
            status='Active',
            admission_id=admissionId
            )
            inv.save()  

        
        elif categoryType=="Diagnosis": ### admission
            medicalServiceCategoryId=self.getPrimaryServiceCategoryIdUnd(medicalServiceCategory,categoryType)
            # inv=diagnosis(
            # name=medicalServiceName,
            # status='Active',
            # service_category_id=medicalServiceCategoryId
            # )
            # inv.save()
            # admissionId=admission.objects.values().aggregate(Max('id'))['id__max']
            inv=diagnosis(
            fee_amount=feeAmount,
            name=medicalServiceName,
            status='Active',
            diagnosis_category_id=medicalServiceCategoryId
            )
            inv.save() 

        else:
            x=x

        #inv.save()
        return categoryType + ' was successfully created'


    
    def updatePrimaryServiceToDb(self, oldMedicalServiceId, medicalServiceCategory, medicalServiceName,feeAmount, categoryType):
        x=0
        inv=''
        print(medicalServiceCategory + "::" + medicalServiceName + "::" + str(feeAmount) + "::" + categoryType)
        medicalServiceCategoryId=0
        if categoryType=="Lab Test":  ##OVER HERE

            medicalServiceCategoryId=self.getPrimaryMedicalServiceId(medicalServiceCategory, categoryType)
            print("medicalServiceCategoryId::" + str(medicalServiceCategoryId))
            inv=lab_test.objects.values().filter(
            id=oldMedicalServiceId
            ).update(lab_test_category_id=medicalServiceCategoryId, name=medicalServiceName,)


            inv=lab_test_fee.objects.values().filter(
            lab_test_id=oldMedicalServiceId
            ).update(fee_amount=feeAmount)


        elif categoryType=="Medicine":  ##OVER HERE

            medicalServiceCategoryId=self.getPrimaryMedicalServiceId(medicalServiceCategory, categoryType)
            print("medicalServiceCategoryId::" + str(medicalServiceCategoryId))
            inv=medicine.objects.values().filter(
            id=oldMedicalServiceId
            ).update(medicine_category_id=medicalServiceCategoryId, name=medicalServiceName, prod_name=medicalServiceName,)




        elif categoryType=="Consultation":
            print("oldMedicalServiceId=" + oldMedicalServiceId + ":::medicalServiceCategory=" + medicalServiceCategory + "::medicalServiceName=" + medicalServiceName + "::feeAmount=" + str(feeAmount) + "::categoryType=" + categoryType)
            medicalServiceCategoryId=self.getPrimaryMedicalServiceId(medicalServiceCategory, categoryType)

            print("medicalServiceCategoryId=" + str(medicalServiceCategoryId))

            inv=consultation.objects.values().filter(
            id=oldMedicalServiceId
            ).update(name=medicalServiceName)

            inv_=consultation_cost.objects.values().filter(
            consultation_id=oldMedicalServiceId
            ).update(status='InActive')

            inv_=consultation_cost(
            consultation_id=oldMedicalServiceId,
            fee_amount=feeAmount,
            status='Active'
            )
            inv_.save()

        elif categoryType=="Admission": ### admission
            inv=admission.objects.values().filter(
            id=oldMedicalServiceId
            ).update(name=medicalServiceName,)


            inv=admission_cost.objects.values().filter(
            admission_id=oldMedicalServiceId
            ).update(status='InActive')

            inv_=admission_cost(
            admission_id=oldMedicalServiceId,
            fee_amount=feeAmount,
            status='Active'
            )
            inv_.save()
        else:
            x=x

        #inv.save()
        return categoryType + ' was successfully updated'


    def updatePrimaryServiceCategoryToDb(self, serviceCategory, oldCategoryId, categoryType):
        x=0
        inv=''
        if categoryType=="Lab Test":
            inv=lab_test_category.objects.values().filter(id=oldCategoryId).update(
            name=serviceCategory,
            status='Active'
            )

        elif categoryType=="Medicine":
            inv=medicine_category.objects.values().filter(id=oldCategoryId).update(
            name=serviceCategory,
            status='Active'
            )
        elif categoryType=="Consultation":
            inv=consultation.objects.values().filter(id=oldCategoryId).update(
            name=serviceCategory,
            status='Active'
            )
        elif categoryType=="Admission":
            inv=admission.objects.values().filter(id=oldCategoryId).update(
            name=serviceCategory,
            status='Active'
            )
        else:
            x=x

        #inv.save()
        return '' + categoryType + ' category was successfully updated'


    def updateServiceCategoryToDb(self, serviceCategory, oldServiceCategoryID):

        inv=service_category.objects.values().filter(
        id=oldServiceCategoryID
        ).update(name=serviceCategory)
        ###inv.save()
        return 'Service category was successfully updated'

    def updateLabTestFeeToInActiveToDb(self, labTestId):
        inv=lab_test_fee.objects.values().filter(
        lab_test_id=labTestId,
        status='Active'
        ).update(status='InActive')
        #inv.save()
        return 'success'

    def insertNewLabTestFeeToDb(self, labTestId, feeAmount):
        self.updateLabTestFeeToInActiveToDb(labTestId)
        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=lab_test_fee(
        lab_test_id=labTestId,
        fee_amount=feeAmount,
        ###creation_date=todayDatee,
        status='Active'
        )
        inv.save()
        return 'Lab Test fee creation was successful'


    def insertNewWagesExpensesToDb(self, _accountId, _amount, _transDate, _details, wagesAccountName):
        inv=expenses(
        account=account.objects.get(id=_accountId),
        amount=_amount,
        trans_date=_transDate,
        bk_status='Active',
        details=_details
        )
        inv.save()
        expensesId=0
        expensesId=expenses.objects.values().aggregate(Max('id'))['id__max']

        employeeId=0
        employeeId=self.getEmployeeId(wagesAccountName)

        employeeWagesId=0
        employeeWagesId=self.getEmployeeWagesId(employeeId)

        inv_=employee_wages_expenses(expenses_id=expensesId, employees_wages_id=employeeWagesId,status='Active')
        inv_.save()
        ###   getEmployeeId(self, wagesAccountName)
        ###   getEmployeeWagesId(self, employeeId)

        return 'success'


    def saveNewExpenses(self, _accountName, _amount, _transDate, _details, wagesAccountName):
        accountId=0
        y=''
        x=0
        _accountName=gen.removeWhiteSpaces(_accountName)
        accountId=self.getAccountId(_accountName)
        if _accountName!='Wages and salaries':
            y=self.insertNewExpensesToDb(accountId, _amount, _transDate,_details)
            x=x
        else:
            y=self.insertNewWagesExpensesToDb(accountId, _amount, _transDate,_details,wagesAccountName)
            x=x

        return y


    def getLabTestId(self, labTestName):
        inv=view_v_lab_test_1_a.objects.values().filter(lab_test_name=labTestName)
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['lab_test_id']
            ##print('y1=' + str(y))
            ####
        else:
            y=y
        return y

    def getServiceCategoryId(self, serviceCategoryName):
        inv=service_category.objects.values().filter(lname=serviceCategoryName,status='Active')
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']
            ##print('y1=' + str(y))
            ####
        else:
            y=y
        return y

    def getMedicineId(self, medicineName):
        inv=view_v_medicine_1_a.objects.values().filter(medicine_name=medicineName)
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['medicine_id']
            ##print('y1=' + str(y))
            ####
        else:
            y=y
        return y

    def getAdmissionId(self, admissionName):
        inv=view_v_admission_cost_1_a.objects.values().filter(admission_name=admissionName)
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['admission_id']
            ##print('y1=' + str(y))
            ####
        else:
            y=y
        return y


    def getServiceCategoryId(self, serviceCategory):

        inv=service_category.objects.values().filter(name__iexact=serviceCategory)
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']

        else:
            y=y
        return y

    def getPrimaryServiceCategoryId(self, serviceCategory, categoryType):
        x=0
        inv=''
        if categoryType=="Lab Test":
            inv=lab_test_category.objects.values().filter(name__iexact=serviceCategory)
            x=x
        elif categoryType=="Medicine":
            inv=medicine_category.objects.values().filter(name__iexact=serviceCategory)
            x=x
        elif categoryType=="Consultation":
            inv=service_category.objects.values().filter(name__iexact=serviceCategory)
            x=x
        elif categoryType=="Admission":
            inv=service_category.objects.values().filter(name__iexact=serviceCategory)
            x=x
        elif categoryType=="Diagnosis":
            inv=service_category.objects.values().filter(name__iexact=serviceCategory)
            x=x
        else:
            x=x

        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']

        else:
            y=y
        return y 
    

    def getPrimaryServiceCategoryIdUnd(self, serviceCategory, categoryType):
        x=0
        inv=''
        if categoryType=="Diagnosis":
            inv=diagnosis_category.objects.values().filter(name__iexact=serviceCategory)
            x=x
        else:
            x=x

        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']

        else:
            y=y
        return y


    def getPrimaryMedicalServiceId(self, medicalService, categoryType):
        x=0
        inv=''
        if categoryType=="Lab Test":
            inv=lab_test_category.objects.values().filter(name__iexact=medicalService)
            x=x
        elif categoryType=="Medicine":
            inv=medicine.objects.values().filter(name__iexact=medicalService)
            x=x
        elif categoryType=="Consultation":
            print("here:::consul:::medicalService=" + medicalService + ":::categoryType=" + categoryType)
            inv=consultation.objects.values().filter(name__iexact=medicalService)
            x=x
        elif categoryType=="Admission":
            inv=admission.objects.values().filter(name__iexact=medicalService)
            x=x   
        elif categoryType=="Diagnosis":
            inv=diagnosis.objects.values().filter(name__iexact=medicalService)
            x=x
        else:
            x=x

        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']

        else:
            y=y
        print("return id=" + str(y))
        return y


    def getServiceId(self, serviceName):

        inv=medical_service.objects.values().filter(name__iexact=serviceName, status='Active')
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']

        else:
            y=y
        return y


    def saveNewAdmissionWithFeeAmount(self, admissionName, feeAmount):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg=''
        #_accountName=gen.removeWhiteSpaces(_accountName)
        admissionId=self.getAdmissionId(admissionName)
        msg=self.insertNewAdmissionFeeToDb(admissionId, feeAmount)

        return msg


    def saveNewMedicalServiceWithFeeAmount(self, serviceCategory, serviceName, feeAmount):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg=''
        #_accountName=gen.removeWhiteSpaces(_accountName)
        serviceCategoryId=0
        serviceCategoryId=self.getServiceCategoryId(serviceCategory)

        serviceNameId=0   ###   getServiceId(self, serviceName)
        serviceNameId=self.getServiceId(serviceName) ### getServiceCategoryId(serviceCategory)
        #admissionId=self.getAdmissionId(admissionName)
        #msg=self.insertNewAdmissionFeeToDb(admissionId, feeAmount)
        msg=self.insertNewMedicalServiceFeeToDb(serviceName, serviceCategoryId, feeAmount)

        return msg

    def saveNewServiceCategory(self, serviceCategory):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg=''
        serviceCategoryId=0
        #_accountName=gen.removeWhiteSpaces(_accountName)
        serviceCategoryId=self.getServiceCategoryId(serviceCategory)
        if serviceCategoryId==0:
            msg=self.insertNewServiceCategoryToDb(serviceCategory)
            ###insertNewAdmissionFeeToDb(admissionId, feeAmount)
            x=x
        else:
            msg='Service Category already exists'

        return msg


    def saveNewPrimaryMedicalServiceCategory(self, medicalServiceCategory, categoryType):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg='' + categoryType
        serviceCategoryId=0
        #_accountName=gen.removeWhiteSpaces(_accountName)
        #if categoryType=="lab":
        serviceCategoryId=self.getPrimaryServiceCategoryId(medicalServiceCategory, categoryType)
        if serviceCategoryId==0:
            msg=self.insertNewPrimaryServiceCategoryToDb(medicalServiceCategory, categoryType)
            x=x
        else:
            msg=' Category already exists'
        
        return msg


    def saveNewPrimaryMedicalService(self, primaryMedicalServiceCategory,primaryMedicalService, feeAmount, serviceCategory):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg='' + serviceCategory
        serviceCategoryId=0
        ###insertNewPrimaryServiceToDb(self, medicalServiceCategory, medicalServiceName,feeAmount, categoryType)
        serviceCategoryId=self.getPrimaryMedicalServiceId(primaryMedicalService, serviceCategory)
        if serviceCategoryId==0:
            msg=self.insertNewPrimaryServiceToDb(primaryMedicalServiceCategory,primaryMedicalService, feeAmount, serviceCategory)
            x=x
        else:
            msg=' Category already exists'

        return msg


    def updateExistingPrimaryMedicalService(self, oldMedicalServiceId, primaryMedicalServiceCategory,primaryMedicalService, feeAmount, serviceCategory):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg='' + serviceCategory
        medicalServiceId=0
        ###insertNewPrimaryServiceToDb(self, medicalServiceCategory, medicalServiceName,feeAmount, categoryType)
        medicalServiceId=self.getPrimaryMedicalServiceId(primaryMedicalService, serviceCategory)

        msg=self.updatePrimaryServiceToDb(oldMedicalServiceId, primaryMedicalServiceCategory, primaryMedicalService,feeAmount, serviceCategory)
        x=x

        #msg=' Category already exists'

        return msg  

    
    
    def updatePrimaryServiceToDbToInActive(self, primaryMedicalServiceId, category):
        x=0
        inv=''
        medicalServiceCategoryId=0
        if category=="Lab Test":  ##OVER HERE

            inv=lab_test.objects.values().filter(
            id=primaryMedicalServiceId
            ).update(status='InActive')

            inv=lab_test_fee.objects.values().filter(
            lab_test_id=primaryMedicalServiceId
            ).update(status='InActive')
        
        elif category=="Medicine":  ##OVER HERE
           
            inv=medicine.objects.values().filter(
            id=primaryMedicalServiceId
            ).update(status='InActive')

        elif category=="Consultation":
            
            inv=consultation.objects.values().filter(
            id=primaryMedicalServiceId
            ).update(status='InActive')

            inv_=consultation_cost.objects.values().filter(
            consultation_id=primaryMedicalServiceId
            ).update(status='InActive')

        elif category=="Admission": ### admission
            inv=admission.objects.values().filter(
            id=primaryMedicalServiceId
            ).update(status='InActive')

            inv=admission_cost.objects.values().filter(
            admission_id=primaryMedicalServiceId
            ).update(status='InActive')
            
        else:
            x=x

        #inv.save()
        return category + ' was successfully deleted'



    def deleteExistingPrimaryMedicalService(self, primaryMedicalServiceId, category):
        labTestId=0
        #view_v_lab_test_1_a   primaryMedicalServiceId, category   deleteExistingPrimaryMedicalService
        y=''
        x=0
        msg='' + category
        medicalServiceId=0
       
        msg=self.updatePrimaryServiceToDbToInActive( primaryMedicalServiceId, category)
        x=x

        #msg=' Category already exists'

        return msg
    



    def updatePrimaryServiceCategoryToDbToInActive(self, serviceCategoryId, categoryType):
        x=0
        inv=''
        if categoryType=="Lab Test":
            inv=lab_test_category.objects.values().filter(id=serviceCategoryId).update(
            status='InActive'
            )

        elif categoryType=="Medicine":
            inv=medicine_category.objects.values().filter(id=serviceCategoryId).update(
            status='InActive'
            )
        elif categoryType=="Consultation":
            inv=consultation.objects.values().filter(id=serviceCategoryId).update(
            status='InActive'
            )
        elif categoryType=="Admission":
            inv=admission.objects.values().filter(id=serviceCategoryId).update(
            status='InActive'
            )
        else:
            x=x

        return '' + categoryType + ' category was successfully deleted'


    def deleteExistingPrimaryMedicalServiceCategory(self, primaryMedicalServiceCategoryId, category):
        labTestId=0
        #view_v_lab_test_1_a   primaryMedicalServiceId, category   deleteExistingPrimaryMedicalService
        y=''
        x=0
        msg='' + category
        medicalServiceId=0
        
        msg=self.updatePrimaryServiceCategoryToDbToInActive(primaryMedicalServiceCategoryId, category)
        #
        x=x
        return msg


    def updateExistingPrimaryMedicalServiceCategory(self,primaryMedicalServiceCategory,oldPrimaryMedicalServiceCategoryId, catType):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg='' + catType
        serviceCategoryId=0
        ###   updatePrimaryServiceCategoryToDb
        #serviceCategoryId=self.getPrimaryServiceCategoryId(medicalServiceCategory, categoryType)
        if serviceCategoryId==0:
            msg=self.updatePrimaryServiceCategoryToDb(primaryMedicalServiceCategory,oldPrimaryMedicalServiceCategoryId, catType)
            x=x
        else:
            msg=' Category already exists'

        return msg


    def updateExistingServiceCategory(self, serviceCategory, oldServiceCategoryId,oldServiceCategoryGl):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg=''
        serviceCategoryId=0
        #_accountName=gen.removeWhiteSpaces(_accountName)
        serviceCategoryId=self.getServiceCategoryId(oldServiceCategoryGl)
        #updateServiceCategoryToDb(self, serviceCategory, oldServiceCategoryID)
        if serviceCategoryId==0:
            msg='Service Category already exists'
            ###insertNewAdmissionFeeToDb(admissionId, feeAmount)
            x=x
        else:

            msg=self.updateServiceCategoryToDb( serviceCategory, oldServiceCategoryId)

        return msg



    def saveNewMedicineWithFeeAmount(self, medicineCategory,medicineName, costAmount,productName,uoqName,qtyPerUOQ):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg=''
        #_accountName=gen.removeWhiteSpaces(_accountName)
        medicineId=self.getMedicineId(medicineName)

        ###   msg=self.insertNewMedicineProductToDb( medicineId, productName, costAmount)
        invNoUsage="Multiple Items by Single restaurant Number"
        UOQSingle=float(qtyPerUOQ)
        UOQHalf=float(1)
        if UOQSingle>1:
            UOQHalf=UOQSingle/2
        UOQQuarter=float(1)
        if UOQSingle>1:
            UOQQuarter=UOQSingle/2
        #UOQSingle,UOQHalf,UOQQuarter   Multiple Items by Single restaurant Number
        itemId=0 
        print("productName=" + str(productName) + " ::: invNoUsage=" + str(invNoUsage) + " ::: uoqName=" + str(uoqName) + " ::: UOQSingle=" + str(UOQSingle) + " ::: UOQHalf=" + str(UOQHalf) + " ::: UOQQuarter" + str(UOQQuarter) + "")
        itemId=newUoq.addNewUoq02(productName,invNoUsage,uoqName,UOQSingle,UOQHalf,UOQQuarter)
        msg=self.insertNewMedicineProductToDb( medicineId, productName, costAmount,itemId)
        return msg

    
    def updateMedicineProductToDbToInActive(self, medicalProductId, category):
        msg='Medicine was successfully deleted'
        todayDatee=str(pur.getTodayDate) + ' ' + str(pur.getTodayTime)
        inv=medicine_product.objects.values().filter(
        id=medicalProductId
        ).update(status='InActive')
        
        #max
        return msg ###'Medicine Cost creation was successful'

    def deleteMedicineProduct(self, medicineProductIdGl, medicineCategory):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg=''
        
        itemId=0
        msg=self.updateMedicineProductToDbToInActive(medicineProductIdGl, medicineCategory)
        return msg


    def updateMedicineWithFeeAmount(self,oldMedicineProductIdGl, medicineCategory,medicineName, costAmount,productName,uoqName,qtyPerUOQ):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg=''
        #_accountName=gen.removeWhiteSpaces(_accountName)
        medicineId=self.getMedicineId(medicineName)

        ###   msg=self.insertNewMedicineProductToDb( medicineId, productName, costAmount)
        invNoUsage="Multiple Items by Single restaurant Number"
        UOQSingle=float(qtyPerUOQ)
        UOQHalf=float(1)
        if UOQSingle>1:
            UOQHalf=UOQSingle/2
        UOQQuarter=float(1)
        if UOQSingle>1:
            UOQQuarter=UOQSingle/2
        #UOQSingle,UOQHalf,UOQQuarter   Multiple Items by Single restaurant Number
        itemId=0
        itemId=newUoq.addNewUoq02(productName,invNoUsage,uoqName,UOQSingle,UOQHalf,UOQQuarter)
        msg=self.updateMedicineProductToDb(oldMedicineProductIdGl, medicineId, productName, costAmount,itemId)
        return msg



    def saveNewLabTestWithFeeAmount(self, labTestCategory,labTestName, feeAmount):
        labTestId=0
        #view_v_lab_test_1_a
        y=''
        x=0
        msg=''
        #_accountName=gen.removeWhiteSpaces(_accountName)
        labTestId=self.getLabTestId(labTestName)
        msg=self.insertNewLabTestFeeToDb(labTestId, feeAmount)

        return msg


    def getAccountId(self, _accountName):
        inv=account.objects.values().filter(name=_accountName, status='Active')
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']
            ##print('y1=' + str(y))
            ####
        else:
            y=y
        return y

    def getEmployeeId(self, wagesAccountName):
        inv=employee.objects.values().filter(name=wagesAccountName, status='Active')
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']
            ##print('y1=' + str(y))
            ####
        else:
            y=y
        return y


    def getEmployeeWagesId(self, employeeId):
        inv=employees_wages.objects.values().filter(employee_id=employeeId, status='Active')
        x=list(inv)
        y=0
        if len(x)>0:
            y=x[0]['id']
            ##print('y1=' + str(y))
            ####
        else:
            y=y
        return y
